#include "tg_common.glsl"

#ifdef _FRAGMENT_

//-----------------------------------------------------------------------------

float   GlowMapSun(vec3 point)
{
    if ((dunesMagn == 1.0) || (hillsMagn == 1.0))       // Changed sun shader
    {
        float hillsFreqReplace = 1000;
        float dunesMagnReplace = 0.5;
        float hillsMagnReplace = 0.03;
        float colorDistFreqReplace = 1.0;
        
        // Flows
        noiseOctaves = 10;
        // vec3  p = point * colorDistFreq + Randomize;
            vec3  p = point * colorDistFreqReplace + Randomize;            // *** That's what matters. No idea why. *** 
            
        vec3  dist = 2.5 * Fbm3D(p * 0.5);
        noiseOctaves = 3;
        float flows = Fbm(p / 7.5 + dist);
        
        // Granularity
        noiseOctaves = 5;
       // p = point * hillsFreq + Randomize;
             p = point * hillsFreqReplace + Randomize;
            
        //dist = dunesMagn * Fbm3D(p * 0.2);
             dist = dunesMagnReplace * Fbm3D(p * 0.2);
            
        vec2  cell = Cell3Noise2(p + dist);
        float gran = smoothstep(0.1, 1.0, sqrt(abs(cell.y - cell.x)));
            
        // Solar spots
        float botMask = -0.15;
        float filMask = -0.05;
        float filaments = 5.0;
        if (mareSqrtDensity > 0.01)
        {
            noiseOctaves = 5;
            SolarSpotsTempNoise(point, botMask, filMask, filaments);
        }

        float granTopTemp = colorParams.z;
        float granBotTemp = colorParams.w;
        float surfTemp = 1.0;
        float filTemp  = granTopTemp;
        float spotTemp = granBotTemp;

        return (flows * 0.642 + mix(granBotTemp, granTopTemp, gran) * (1.0 - filMask)) * mix(spotTemp, surfTemp, botMask) + filMask * mix(spotTemp, filTemp, filaments);
    }
    else	// Normal sun shader 
    {
        // Flows
        noiseOctaves = 5;
        vec3  p = point * colorDistFreq + Randomize;
        vec3  dist = 2.5 * Fbm3D(p * 0.5);
        noiseOctaves = 3;
        float flows = Fbm(p * 7.5 + dist);

        // Granularity
        noiseOctaves = 5;
        p = point * hillsFreq + Randomize;
        dist = dunesMagn * Fbm3D(p * 0.2);
        vec2  cell = Cell3Noise2(p + dist);
        float gran = smoothstep(0.1, 1.0, sqrt(abs(cell.y - cell.x)));

        // Solar spots
        float botMask = 1.0;
        float filMask = 0.0;
        float filaments = 0.0;
        if (mareSqrtDensity > 0.01)
        {
            noiseOctaves = 5;
            SolarSpotsTempNoise(point, botMask, filMask, filaments);
        }

        float granTopTemp = colorParams.z;
        float granBotTemp = colorParams.w;
        float surfTemp = 1.0;
        float filTemp  = granTopTemp;
        float spotTemp = granBotTemp;

        return (flows * 0.1 + mix(granBotTemp, granTopTemp, gran) * (1.0 - filMask)) * mix(spotTemp, surfTemp, botMask) + filMask * mix(spotTemp, filTemp, filaments);
    }
}

//-----------------------------------------------------------------------------

void main()
{
    vec3  point = GetSurfacePoint();
    float surfTemp = GlowMapSun(point);
    surfTemp *= surfTemperature; // in thousand Kelvins
    OutColor.rgb = UnitToColor24(log(surfTemp) * 0.188 + 0.1316);
    OutColor.a = 1.0;
}

//-----------------------------------------------------------------------------

#endif
